function [featparams, learnparams, infer_params] = msrc_full()

fprintf('params for using full model\n')
%The following are learning parameters:
learnparams.p = 2;         %use p norm as the regularization term
learnparams.C = 0.02;      %the weight of regularization
learnparams.epsilon = 1;   %epsilon = 1 means maximize the marginal probability of CRF model
learnparams.rGap = 1e-3;   %the relative gap between Primal and Dual
learnparams.it = 1000;    %the maximum Number of Iterations 

%The following are inference parameters:
infer_params.c = 25;      %the number of clients
infer_params.s = 25;      %the number of servers
infer_params.eps = 1;      %the same meaning as that in learning
infer_params.r = 1e-3;     %the same as learning


featparams.segFeature = 1;              % use supersegments?
featparams.chowliuFeature = 1;          % use Chow-Liu?
featparams.SceneFeature = 1;
featparams.SceneSupressZFeature = 0;     % either this or the one below should always be on!
featparams.SceneBoostZFeature = 1;
featparams.uselogisticScene = 1;
featparams.usesupressinboost = 1;
featparams.suppress_gamma = 15;     %must be positive,default is 1

% It's optional to add more features, but from our result, it does not have
% much difference
featparams.useSPLocationFeature = 0;   % use location feature for SP?
featparams.useSSLocationFeature = 0;     % use location feature for SS?
featparams.useFgBg = 0;
featparams.useClassSP = 0;

% loss factors:
featparams.superpixfactor = 5;  %default is 5
featparams.supersegfactor = 1;   %default is 1
featparams.Zfactor = 5;         %default is 5
featparams.Bfactor = 100;        %default is 50/1000
featparams.Scenefactor = 10;    %default is 10

featparams.det_classes = [5 7 10 12 13 14 15 16 17 18 19 21 22 23 24]';%{'cow', 'sheep', 'aeroplane', 'face', 'car','bicycle', 'flower', 'sign', 'bird', 'book', 'chair', 'cat', 'dog', 'body', 'boat'};
          
featparams.boxthresh = 0.35;          % a thresh on bi=1 in training
featparams.pascalloss = 1;            % pascalloss=1 for PASCAL bbox loss or 0 if you want to force bboxes to be 1       

% other
featparams.use1_meta = 0;
featparams.uselogistic = 1;

