function [featparams, learnparams, infer_params] = msrc_sp_seg_Z()

fprintf('params for using only SP, Seg (both levels) and class potentials\n');
%The following are learning parameters:
learnparams.p = 2;         %use p norm as the regularization term
learnparams.C = 0.02;      %the weight of regularization
learnparams.epsilon = 1;   %epsilon = 1 means maximize the marginal probability of CRF model
learnparams.rGap = 1e-3;   %the relative gap between Primal and Dual
learnparams.it = 1000;    %the maximum Number of Iterations 

%The following are inference parameters:
infer_params.c = 25;      %the number of clients
infer_params.s = 25;      %the number of servers
infer_params.eps = 1;      %the same meaning as that in learning
infer_params.r = 1e-3;     %the same as learning


featparams.segFeature = 1;              % use supersegments?
featparams.chowliuFeature = 1;          % use Chow-Liu?
featparams.SceneFeature = 0;

% loss factors:
featparams.superpixfactor = 5;  %default is 5
featparams.supersegfactor = 1;   %default is 1
featparams.Zfactor = 5;         %default is 5

featparams.det_classes = []';%{'cow', 'sheep', 'aeroplane', 'face', 'car','bicycle', 'flower', 'sign', 'bird', 'book', 'chair', 'cat', 'dog', 'body', 'boat'};

