% Get Binary Potential for bainary variable
function [stats freq wfreq] = computeFrequencyOfClasses(DATASET_NAME)

if ~exist('DATASET_NAME','var')
    DATASET_NAME = 'msrc';
end

dataset_globals;
[~, gtcols] = getclassinfo(DATASET_NAME);

setfile = fullfile(TRAIN_FILE);
GT_PATH = fullfile(ALLPATHS.GT_PATH);
Chow_Liu = fullfile(ALLPATHS.CHOWLIU_PATH);

if ~exist(ALLPATHS.Z_FEATURE_PATH,'dir')
    mkdir(ALLPATHS.Z_FEATURE_PATH);
end

if ~exist(Chow_Liu,'dir')
    mkdir(Chow_Liu);
end

fid = fopen(setfile,'r');
T = textscan(fid,'%s');
Files = T{1};
if exist('Chow_Liu','var') && exist(fullfile(Chow_Liu,'chowliu_MSRC.mat'),'file')
    chowliuFile = load(fullfile(Chow_Liu,'chowliu_MSRC.mat'));
    [r c] = find(chowliuFile.adjmat);
    pairs = [r c];
    pairs(r>c,:) = [];
    edge_weights = chowliuFile.edge_weights;
end

cooccur = zeros(size(pairs,1),1);
leftPre = cooccur;
rightPre = cooccur;
nonePre = cooccur;
PresentNum = zeros(21,1);
MissingNum = zeros(21,1);

for i = 1:length(Files)
    [~, name, ~] = fileparts(Files{i});
    I = imread(fullfile(GT_PATH,[name '_GT.bmp']));
    labels = get_GTclasslabels(I, gtcols, IGNORE_CLASSES, DATASET_NAME);
    Classes = unique(labels);
    Classes(Classes==0) = [];
%     switch(DATASET_NAME)
%         case 'msrc'
%             gtim = rgb2ind(I,labelMapping);
%             gtim(gtim == 5) = 0;
%             gtim(gtim == 8) = 0;
%             Classes = unique(gtim);
%             Classes = Classes + 1;
%             Classes = find_ind_class(Classes,IGNORE_CLASSES);
%             Classes(Classes == 1) = [];
%             Classes = Classes - 1;
%         case 'voc'
%             Classes = unique(I);
%             Classes(Classes == 255) = [];
%             Classes = Classes + 1;
%     end
            
    for j = 1:21
        if sum(Classes==j) > 0
            [row col] = find(pairs==j);
            for k = 1:length(row)
                if sum(Classes==pairs(row(k),3-col(k))) > 0
                    if col(k)==1
                        cooccur(row(k)) = cooccur(row(k)) + 1;    % (1 1)
                    end
                else 
                    if col(k)==1
                        leftPre(row(k)) = leftPre(row(k)) + 1;                % (1 0)
                    else if col(k)==2
                            rightPre(row(k)) = rightPre(row(k)) + 1;            % (0 1)
                        end
                    end
                end
            end
            PresentNum(j) = PresentNum(j) + 1;
        else
            MissingNum(j) = MissingNum(j) + 1;
        end
    end
    
    for j = 1:size(pairs,1)
        if (sum(pairs(j,1)==Classes) || sum(pairs(j,2)==Classes)) ==0
            nonePre(j) = nonePre(j)+1;             % (0 0)
        end
    end
end

stats = [MissingNum PresentNum]/length(Files);    
chowliuFreq = [nonePre leftPre rightPre cooccur];
freq = chowliuFreq./repmat(sum(chowliuFreq,2),1,4);

weight = zeros(size(pairs,1),1);
for i = 1:size(pairs,1)
    weight(i) = edge_weights(pairs(i,1),pairs(i,2));
end
wfreq = freq.*repmat(weight,1,4);

save(fullfile(ALLPATHS.Z_FEATURE_PATH,'frequency.mat'),'stats','freq','wfreq');
        
        
        
    
    

